# -*- coding:Utf-8 -*-
import es, psyco
psyco.full()


admin = set()
command = set()

class DmConfig(object):
    """ Config Management """
    def __init__(self):
        self.steamid = es.ServerVar("dp_admin_steamid", "", "[dm_python] administrator steamid")
        self.admin = es.ServerVar("dp_admin_command", "", "[dm_python] administrator menu command")
        self.command = es.ServerVar("dp_menu_command", "", "[dm_python] deathmatch menu command")
        self.timeout = es.ServerVar("dp_menu_timeout", "", "[dm_python] menu time out")
        self.method = es.ServerVar("dp_respawn_method", "", "[dm_python] plugin used for respawn players")
        self.random = es.ServerVar("dp_respawn_random", "", "[dm_python] respawn player at his team spawn")
        self.respawn = es.ServerVar("dp_respawn_time", "", "[dm_python] time for respawn players")
        self.dissolver = es.ServerVar("dp_ragdoll_dissolver", "", "[dm_python] dissolve ragdoll")

        self.assaultsuit = es.ServerVar("dp_give_assaultsuit", "", "[dm_python] give assaultsuit")
        self.nightvision = es.ServerVar("dp_give_nightvision", "", "[dm_python] give nightvision")
        self.hegrenade = es.ServerVar("dp_hegrenade_max", "", "[dm_python] hegrenade max")
        self.flashbang = es.ServerVar("dp_flashbang_max", "", "[dm_python] flashbang max")
        self.smokegrenade = es.ServerVar("dp_smokegrenade_max", "", "[dm_python] smokegrenade max")
        self.botPrimary = es.ServerVar("dp_bot_primary", "", "[dm_python] primary weapon allowed for bot")
        self.botSecondary = es.ServerVar("dp_bot_secondary", "", "[dm_python] secondary weapon allowed for bot")

        es.regclientcmd("_dp_cvar_admin", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_command", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_timeout", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_method", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_random", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_respawn", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_dissolver", "dm_python/cvarValue", "[dm_python] internal command for in-game config")

        es.regclientcmd("_dp_cvar_assaultsuit", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_nightvision", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_hegrenade", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_flashbang", "dm_python/cvarValue", "[dm_python] internal command for in-game config")
        es.regclientcmd("_dp_cvar_smokegrenade", "dm_python/cvarValue", "[dm_python] internal command for in-game config")

    def __contains__(self, item):
        return item in map(lambda steamid: steamid.strip(), str(self.steamid).split(","))

    def __getitem__(self, item):
        if item == "admin": return self.admin
        elif item == "command": return self.command
        elif item == "timeout": return self.timeout
        elif item == "method": return self.method
        elif item == "random": return self.random
        elif item == "respawn": return self.respawn
        elif item == "dissolver": return self.dissolver
        elif item == "assaultsuit": return self.assaultsuit
        elif item == "nightvision": return self.nightvision
        elif item == "hegrenade": return self.hegrenade
        elif item == "flashbang": return self.flashbang
        elif item == "smokegrenade": return self.smokegrenade

    def saveCfg(self):
        path = es.server_var["eventscripts_gamedir"] + "/cfg/dm_python/"
        try:
            config = open(path + "config.cfg", "w")
            config.write(
                "// config.cfg for dm_python script\n" +
                "// 2010/06/13 version 2.0p by DoCky\n\n\n" +
                '// X = administrator steamid\ndp_admin_steamid "%s"\n\n' % self.steamid +
                '// X = administrator menu command\ndp_admin_command "%s"\n\n' % self.admin +
                '// X = deathmatch menu command\ndp_menu_command "%s"\n\n' % self.command +
                '// X = close menu after X second, 0 = do not close automatically\ndp_menu_timeout "%s"\n\n' % self.timeout +
                '// X = plugin used for respawn a player, "es_tools", "sp_extensions" (SPE)\ndp_respawn_method "%s"\n\n' % self.method +
                '// 1 = respawn player at his team spawn\ndp_respawn_random "%s"\n\n' % self.random +
                '// X = time for respawn a player\ndp_respawn_time "%s"\n\n' % self.respawn +
                '// 1 = dissolve ragdoll\ndp_ragdoll_dissolver "%s"' % self.dissolver)
            config.close()
        except IOError: es.dbgmsg(0, "dm_python: cannot read file cfg/dm_python/config.cfg")

        try:
            items = open(path + "items.cfg", "w")
            items.write(
                "// items.cfg for dm_python script\n" +
                "// 2010/06/13 version 2.0p by DoCky\n\n\n" +
                '// 1 = give kevlar and helmet\ndp_give_assaultsuit "%s"\n\n' % self.assaultsuit +
                '// 1 = give nightvision\ndp_give_nightvision "%s"\n\n' % self.nightvision +
                '// X = give nightvision\ndp_hegrenade_max "%s"\n\n' % self.hegrenade +
                '// X = flashbang max\ndp_flashbang_max "%s"\n\n' % self.flashbang +
                '// X = smokegrenade max\ndp_smokegrenade_max "%s"\n\n' % self.smokegrenade +
                '// X = allowed primary weapons for bots, 0 = all\ndp_bot_primary "%s"\n\n' % self.botPrimary +
                '// X = allowed secondary weapons for bots, 0 = all\ndp_bot_secondary "%s"\n\n' % self.botSecondary)
            items.close()
        except IOError: es.dbgmsg(0, "dm_python: cannot read file cfg/dm_python/items.cfg")

    def execCfg(self):
        es.server.cmd("es_xmexec dm_python/config.cfg")
        es.server.cmd("es_xmexec dm_python/items.cfg")

    def createCmd(self):
        self.deleteCmd()
        for word in map(lambda word: word.strip(), str(self.command).split(",")):
            command.add(word)
            es.regsaycmd(word, "dm_python/deathmatchMenu", "[dm_python] deathmatch menu acces")
            es.regclientcmd(word, "dm_python/deathmatchMenu", "[dm_python] deathmatch menu acces")

        for word in map(lambda word: word.strip(), str(self.admin).split(",")):
            command.add(word)
            es.regsaycmd(word, "dm_python/administratorMenu", "[dm_python] administrator menu acces")
            es.regclientcmd(word, "dm_python/administratorMenu", "[dm_python] administrator menu acces")

    def deleteCmd(self):
        for word in command:
            es.unregsaycmd(word)
            es.unregclientcmd(word)
        for word in admin:
            es.unregsaycmd(word)
            es.unregclientcmd(word)
        command.clear(), admin.clear()

    def unload(self):
        self.saveCfg()
        self.deleteCmd()
        es.unregclientcmd("_dp_cvar_admin")
        es.unregclientcmd("_dp_cvar_command")
        es.unregclientcmd("_dp_cvar_timeout")
        es.unregclientcmd("_dp_cvar_method")
        es.unregclientcmd("_dp_cvar_random")
        es.unregclientcmd("_dp_cvar_respawn")
        es.unregclientcmd("_dp_cvar_dissolver")

        es.unregclientcmd("_dp_cvar_assaultsuit")
        es.unregclientcmd("_dp_cvar_nightvision")
        es.unregclientcmd("_dp_cvar_hegrenade")
        es.unregclientcmd("_dp_cvar_flashbang")
        es.unregclientcmd("_dp_cvar_smokegrenade")
